]> diplodocus.org Git - nmh/blob - test/common.sh.in
Added const to argument of getname().
[nmh] / test / common.sh.in
1 # Common helper routines for test shell scripts -- intended to be sourced by them
2 # @configure_input@
3
4
5 #### The following exported variables are set by "make check". Ensure
6 #### that they are set here so that individual tests can be run
7 #### outside of make. Requires that MH_OBJ_DIR be set on entry.
8 test -z "$MH_TEST_DIR" && MH_TEST_DIR="$MH_OBJ_DIR/test/testdir"
9 test -z "$prefix" && prefix=@prefix@
10 test -z "$datarootdir" && datarootdir=@datarootdir@
11 test -z "$exec_prefix" && exec_prefix=@exec_prefix@
12 test -z "$auxexecdir" && auxexecdir="@libdir@"
13 test -z "$bindir" && bindir="@bindir@"
14 test -z "$mandir" && mandir="@mandir@"
15 test -z "$sysconfdir" && sysconfdir="@sysconfdir@"
16 test -z "$supported_locks" && supported_locks="@supported_locks@"
17 test -z "$MULTIBYTE_ENABLED" && MULTIBYTE_ENABLED="@MULTIBYTE_ENABLED@"
18 test -z "$ICONV_ENABLED" && ICONV_ENABLED="@ICONV_ENABLED@"
19 export MH_TEST_DIR auxexecdir bindir mandir sysconfdir
20 export MULTIBYTE_ENABLED ICONV_ENABLED
21
22 test -z "$MH_INST_DIR" && MH_INST_DIR="${MH_TEST_DIR}/inst"
23 export MH_INST_DIR
24
25 unset MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE
26 unset MHLDEBUG MHPDEBUG MHWDEBUG MM_CHARSET PAGER
27
28 #### Use a test dir for tmp files when MHTMPDIR applies.
29 MHTMPDIR=$MH_TEST_DIR/Mail
30 export MHTMPDIR
31
32 output_md5()
33 {
34 #### Output just the checksum. If the filename needs to appear on
35 #### the same line, the caller needs to add it. This avoids
36 #### differences due to a leading '*' binary file indicator, for
37 #### text files, on some platforms (Cygwin).
38 @MD5SUM@ $* | @MD5FMT@ | cut -d ' ' -f 1
39 }
40
41 #### Use built-in $((...)) in test suite if shell supports it.
42 #### Borrowed from configure's as_fn_arith. The result is placed
43 #### in global arith_val.
44 #### Detected at run-time instead of by configure to allow testing
45 #### with different shells.
46 if (eval "test \$(( 1 + 1 )) = 2" 2>/dev/null); then
47 eval 'arith_eval () { arith_val=$(( $* )); }'
48 else
49 arith_eval () { arith_val=`expr "$@" || test $? -eq 1`; }
50 fi
51
52 test_skip ()
53 {
54 WHY="$1"
55 echo "$Test $0 SKIP ($WHY)"
56 exit 77
57 }
58
59 # portable implementation of 'which' utility
60 findprog()
61 {
62 PROG="$1"
63 #### Don't need to save current IFS because this function is run in
64 #### a subshell.
65 IFS=:
66 for D in $PATH; do
67 if [ -z "$D" ]; then
68 D=.
69 fi
70 if [ -f "$D/$PROG" -a -x "$D/$PROG" ]; then
71 printf '%s\n' "$D/$PROG"
72 break
73 fi
74 done
75 }
76
77 require_prog ()
78 {
79 if [ -z "`findprog $1`" ]; then
80 test_skip "missing $1"
81 fi
82 }
83
84 # Some stuff for doing silly progress indicators
85 if [ -t 1 ] ; then
86 progress_update ()
87 {
88 THIS="$1"
89 FIRST="$2"
90 LAST="$3"
91 arith_eval $LAST - $FIRST; RANGE=$arith_val
92 arith_eval $THIS - $FIRST; PROG=$arith_val
93 # this automatically rounds to nearest integer
94 arith_eval 100 \* $PROG / $RANGE; PERC=$arith_val
95 # note \r so next update will overwrite
96 printf '%3d%%\r' $PERC
97 }
98
99 progress_done ()
100 {
101 printf '100%%\n'
102 }
103 else
104 # don't emit anything if stdout is not connected to a tty.
105 progress_update ()
106 {
107 :
108 }
109 progress_done ()
110 {
111 :
112 }
113 fi
114
115 check_for_hard_links () {
116 set +e
117
118 printf '' > "${MH_TEST_DIR}/$$-1"
119 if link "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2" 2>/dev/null; then
120 hard_links_supported=1
121 else
122 hard_links_supported=0
123 fi
124 rm -f "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2"
125
126 set -e
127 }
128
129 #### check() requires two arguments, each the name of a file to be
130 #### diff'ed.
131 #### If the same, the second file is removed. And the first file is
132 #### removed unless the optional third argument has a value of
133 #### 'keep first'.
134 #### If different, global variable "failed" is incremented.
135 check() {
136 #### POSIX diff should support -c.
137 if cmp -s "$1" "$2"; then
138 test $# -lt 3 -o "$3" != 'keep first' && rm -f "$1"
139 rm -f "$2"
140 else
141 echo
142 diff -c "$1" "$2" || true
143 echo
144 echo "$0: test failed, outputs are in $1 and $2."
145 failed=`expr ${failed:-0} + 1`
146 fi
147 }
148
149 #### run_test() requires two arguments, the first is a program and
150 #### arguments, the second is its expected one-line output string.
151 #### If the actual output does not match that string:
152 #### an error message is printed and global variable "failed" is incremented;
153 #### if there is an optional third argument, it is used in the error message.
154 run_test() {
155 set +e
156 actual_output=`$1 2>&1`
157 set -e
158 if test x"$actual_output" != x"$2"; then
159 echo "$0: ${3:-\"$1\"} expected:" 1>&2
160 echo " '$2'" 1>&2
161 echo "but instead got:" 1>&2
162 echo " '$actual_output'" 1>&2
163 failed=`expr ${failed:-0} + 1`
164 fi
165 }
166
167 setup_test ()
168 {
169 MH="${MH_TEST_DIR}/Mail/.mh_profile"
170 MHMTSCONF="${MH_INST_DIR}${sysconfdir}/mts.conf"
171 MH_LIB_DIR="${MH_INST_DIR}${auxexecdir}"
172 export MH MHMTSCONF MH_LIB_DIR
173
174 #
175 # Only install once
176 #
177 if [ -d "${MH_INST_DIR}${bindir}" ]; then
178 :
179 else
180 (cd "${MH_OBJ_DIR}" &&
181 make DESTDIR="${MH_INST_DIR}" SETGID_MAIL= install) ||
182 exit 1
183
184 #### Don't test with sendmail because it would really send the
185 #### mail. If configured to use sendmail, change to smtp instead
186 #### so that we use fakesmtp.
187 #### And set up the maildrop in the test directory so tests don't
188 #### use the user's real maildrop.
189 #### test-slocal needs to look at the original mts.conf, so save it.
190 mv -f "${MHMTSCONF}" "${MHMTSCONF}.old"
191 sed -e 's/mts: *.*/mts: smtp/' \
192 -e "s%mmdfldir: *.*%mmdfldir: ${MH_TEST_DIR}/Mail%" \
193 -e 's%mmdflfil: *.*%mmdflfil: maildrop%' \
194 "${MHMTSCONF}.old" >"${MHMTSCONF}"
195 fi
196
197 #### On Solaris, must set PATH after the install!
198 PATH="${MH_INST_DIR}${bindir}:${PATH}"
199 export PATH
200
201 # clean old test data
202 trap "rm -rf '$MH_TEST_DIR/Mail'" 0
203 # setup test data
204 mkdir -p "$MH_TEST_DIR/Mail" || exit 1
205 cat > "$MH" <<EOF || exit 1
206 Path: ${MH_TEST_DIR}/Mail
207 buildmimeproc: ${MH_INST_DIR}${bindir}/mhbuild
208 fileproc: ${MH_INST_DIR}${bindir}/refile
209 libdir: ${MH_LIB_DIR}
210 mhbuild: -nocontentid
211 mhlproc: ${MH_LIB_DIR}/mhl
212 moreproc: cat
213 postproc: ${MH_LIB_DIR}/post
214 showproc: ${MH_LIB_DIR}/mhl
215 EOF
216
217 for f in MailAliases components digestcomps distcomps forwcomps mhl.body \
218 mhl.digest mhl.format mhl.forward mhl.headers mhl.reply \
219 mhn.defaults rcvdistcomps replcomps replgroupcomps scan.MMDDYY \
220 scan.YYYYMMDD scan.default scan.highlighted scan.mailx scan.nomime \
221 scan.size scan.time scan.timely scan.unseen
222 do
223 cp "${MH_INST_DIR}${sysconfdir}/${f}" "${MH_TEST_DIR}/Mail" || exit 1
224 done
225
226 folder -create +inbox > /dev/null
227 # create 10 basic messages
228 for i in 1 2 3 4 5 6 7 8 9 10;
229 do
230 cat > $MH_TEST_DIR/Mail/inbox/$i <<EOF || exit 1
231 From: Test$i <test$i@example.com>
232 To: Some User <user@example.com>
233 Date: Fri, 29 Sep 2006 00:00:00
234 Message-Id: $i@test.nmh
235 Subject: Testing message $i
236
237 This is message number $i
238 EOF
239 done
240 }